#!/usr/bin/ruby
# encoding: utf-8

require 'gtk2'
require 'vte'
require "rexml/document"
require 'optparse'

def change_active_box(num)
	if (num < 8) 
		@active_boxes_left.each { |b| b.hide_all }
		@inactive_boxes_left.each { |b| b.show_all }
		@inactive_boxes_left[num].hide_all
		@active_boxes_left[num].show_all
	elsif (num > 16)
		@active_boxes_left.each { |b| b.hide_all }
		@inactive_boxes_left.each { |b| b.show_all }
	end
	@rightboxes.each { |n|
		n.each { |o|
			o.hide_all
		}
	}
	@rightboxes[num].each { |o| o.show_all }
	@groupnames.each { |n| n.hide_all }
	@groupnames[num].show_all 
end

Gtk.init
@active_boxes_left = []
@inactive_boxes_left = []
@rightboxes = [] 


window = Gtk::Window.new
window.window_position = Gtk::Window::POS_CENTER_ALWAYS
window.set_size_request(1020, 630)
window.border_width = 0
window.deletable = false
window.decorated = false
window.allow_grow = false
window.allow_shrink = false
window.title = "Notfall-DVD"
window.signal_connect('delete_event') { false }
window.signal_connect('destroy') { 
	# system("rm /var/run/lesslinux/assistant_running")
	Gtk.main_quit
}

bgimg = Gtk::Image.new("images/winbg.png")
fixed = Gtk::Fixed.new
fixed.put(bgimg, 0, 0)
minimize = Gtk::EventBox.new.add(Gtk::Image.new("images/minimize.png"))
# fixed.put(minimize, 0, 0)
minimize.signal_connect('button_release_event') {
	puts "Minimize"
	window.iconify
}

# Add buttons top
topbuttons = [
	Gtk::EventBox.new.add(Gtk::Image.new("images/button_off.png")),
	Gtk::EventBox.new.add(Gtk::Image.new("images/button_info.png")),
	Gtk::EventBox.new.add(Gtk::Image.new("images/button_kbd.png")),
	Gtk::EventBox.new.add(Gtk::Image.new("images/button_tv.png")),
	Gtk::EventBox.new.add(Gtk::Image.new("images/button_usb.png")),
	Gtk::EventBox.new.add(Gtk::Image.new("images/button_network.png")),
	Gtk::EventBox.new.add(Gtk::Image.new("images/button_lock.png"))
]
topboffsets = [ 973, 942, 902, 869, 844, 808, 784  ]
topbcommandscreens = [
	nil,
	18,
	nil,
	nil,
	17,
	nil, 
	nil
]
topbcommandstrings = [ 
	"shutdown-wrapper.sh",
	nil,
	"connman-gtk",
	"exo-open /usr/share/applications/teamviewer.desktop",
	nil,
	"connman-gtk",
	"connman-gtk"
]

# Add buttons left
#leftbuttons = [
#	Gtk::EventBox.new.add(Gtk::Image.new("images/menu1.png")),
#	Gtk::EventBox.new.add(Gtk::Image.new("images/menu2.png")),
#	Gtk::EventBox.new.add(Gtk::Image.new("images/menu3.png")),
#	Gtk::EventBox.new.add(Gtk::Image.new("images/menu4.png")),
#	#Gtk::EventBox.new.add(Gtk::Image.new("images/menu5.png")),
#	#Gtk::EventBox.new.add(Gtk::Image.new("images/menu6.png"))
#]
#~ rightimages = [
	#~ [
		#~ "images/HACK-GUI-main-1-0.png",
		#~ "images/HACK-GUI-main-1-1.png",
		#~ "images/HACK-GUI-main-1-2.png",
		#~ "images/HACK-GUI-main-1-3.png" ],
	#~ [
		#~ "images/HACK-GUI-main-2-0.png",
		#~ "images/HACK-GUI-main-2-1.png",
		#~ "images/HACK-GUI-main-2-2.png",
		#~ "images/HACK-GUI-main-2-3.png" ],
	#~ [
		#~ "images/HACK-GUI-main-3-0.png",
		#~ "images/HACK-GUI-main-3-1.png",
		#~ "images/HACK-GUI-main-3-2.png",
		#~ "images/HACK-GUI-main-3-3.png",
		#~ "images/HACK-GUI-main-3-4.png" ],
	#~ [
		#~ "images/HACK-GUI-main-4-0.png",
		#~ "images/HACK-GUI-main-4-1.png",
		#~ "images/HACK-GUI-main-4-2.png" ],
	#~ #[
	#~ #	"images/HACK-GUI-main-5-0.png",
	#~ #	"images/HACK-GUI-main-5-1.png" ],
	#~ #[
	#~ #	"images/HACK-GUI-main-6-0.png",
	#~ #	"images/HACK-GUI-main-6-1.png",
	#~ #	"images/HACK-GUI-main-6-2.png", 
	#~ #	"images/HACK-GUI-main-6-3.png" ]
#~ ]
#~ rightcommands = [
	#~ [
		#~ "exo-open /usr/share/applications/080_photorec.desktop",
		#~ "search-caches.sh",
		#~ "photorec-sorter.sh" ],
	#~ [
		#~ "history-extractor.sh",
		#~ "pst-importer.sh",
		#~ "jumplist-extractor.sh" ],
	#~ [
		#~ "xfce4-terminal --hide-menubar -e 'sudo openvas-wrapper' ",
		#~ "exo-open /usr/share/applications/snort.desktop",
		#~ "exo-open /usr/share/applications/wireshark.desktop",
		#~ "exo-open /usr/share/applications/wpa-cracker.desktop" ],
	#~ [
		#~ "exo-open /usr/share/applications/vdiskimage.desktop",
		#~ "sudo /usr/bin/qemustarter.sh" ],
	#~ #[
	#~ #	"exo-open /usr/share/applications/060_usbinstall.desktop" ],	
	#~ #[
	#~ #	"exo-open /usr/share/applications/teamviewer.desktop",
	#~ #	"exo-open /usr/share/applications/runx11vnc.desktop",
	#~ #	"exo-open /usr/share/applications/remmina.desktop" ]
#~ ]
#~ rightpixbufs = Array.new
#~ rightimages.each { |i|
	#~ rightpixbufs.push(Gtk::Image.new(i[0]))
#~ }
#~ rightboxes = Array.new
#~ rightpixbufs.each { |b|
	#~ rightboxes.push(Gtk::EventBox.new.add(b))
#~ }
#~ rightboxes.each { |b|
	#~ fixed.put(b, 320, 160)
#~ }
#~ 0.upto(rightimages.size - 1) { |n|
	#~ rightboxes[n].signal_connect("button_press_event") { |obj, event|
		#~ puts "Y position: #{event.y}"
		#~ if event.x > 50 && event.x < 600 
			#~ el = (event.y - 84.0) / 80.0
			#~ unless rightimages[n][el.to_i + 1].nil?
				#~ rightpixbufs[n].file = rightimages[n][el.to_i + 1]
			#~ end
		#~ end
	#~ }
	#~ rightboxes[n].signal_connect("button_release_event") { |obj, event|
		#~ rightpixbufs[n].file = "images/HACK-GUI-main-" + (n+1).to_s + "-0.png"
		#~ if event.x > 50 && event.x < 600 
			#~ el = (event.y - 84.0) / 80.0
			#~ unless rightcommands[n][el.to_i].nil?
				#~ system(rightcommands[n][el.to_i] + " &")
			#~ end
		#~ end
	#~ }
#~ }

#leftbuttons.each{ |b| 
#	fixed.put(b, 0, 160)
#	b.signal_connect("button_release_event") { |obj, event|
#		puts event.class
#		puts event.x
#		puts event.y
#		el = (event.y - 16.0) / 64
#		unless el < 0.0 || el.to_i  >= leftbuttons.size 
#			puts "Clicked #{el.to_s}"
#			leftbuttons.each{ |b| b.hide_all } 
#			leftbuttons[el.to_i].show_all
#			rightboxes.each{ |b| b.hide_all } 
#			rightboxes[el.to_i].show_all
#		end
#	}
#} 

# buttons left

0.upto(7) { |n|
	inactbox = Gtk::EventBox.new.add(Gtk::Image.new("images/left/#{n+1}_inactive.png"))
	actbox = Gtk::EventBox.new.add(Gtk::Image.new("images/left/#{n+1}_active.png"))
	# 120 , 55
	fixed.put(inactbox, 0, 175 + 55 * n) 
	inactbox.signal_connect("button_release_event") {
		puts n.to_s 
		change_active_box(n)
	}
	fixed.put(actbox, 0, 175 + 55 * n) 
	actbox.signal_connect("button_release_event") {
		puts n.to_s 
		change_active_box(n)
	}
	@active_boxes_left.push actbox
	@inactive_boxes_left.push inactbox
}

# 1 Windows reparieren
# 2 Daten wiederherstellen
# 3 Dateien reparieren
# 4 Daten sichern
# 5 Daten vernichten
# 6 PC-Sicherheit
# 7 Hardware reparieren
# 8 Tips und Tricks

# 9 Windows reparieren -> DVD # 2 
# 10 Daten wiederherstellen -> Backup zurück # 2 
# 11 Daten sichern -> Daten manuell sichern # 3 
# 12 Daten sichern -> Festplatte sichern und wiederh... # 2 
# 13 Daten sichern -> Festplatte klonen # 2 
# 14 PC Sicherheit -> Sicherheitscheck # 3 
# 15 PC Sicherheit -> Sicher surfen # 2
# 16 Hardware reparieren -> Hardware testen # 5 
# 17 Hardware reparieren -> Hardware testen -> USB-Laufwerk prüfen  # 2 
# 18 USB Installation # 3 
# 19 Info # 5
# 20 Info -> Umsetzung # 4

# Buttons right
@buttoncounts = [
	4, 4, 3, 4, 3, 4, 4, 3, 
	1, 1, 2, 1, 1, 2, 1, 4, 1, 2, 4, 3
] 
@subscreens = [
	[ nil, nil, nil, nil, 8 ], # 1 Windows reparieren
	[ nil, nil, nil, nil, 9 ], # 2 Daten wiederherstellen
	[ nil, nil, nil, nil, nil ], # 3 Dateien reparieren
	[ nil, 10, 11, 12, nil ], # 4 Daten sichern
	[ nil, nil, nil, nil, nil ], # 5 Daten vernichten
	[ nil, 13, 14, nil, nil ], # 6 PC-Sicherheit
	[ nil, nil, nil, nil, 15 ], # 7 Hardware reparieren
	[ nil, nil, nil, nil, nil ], # 8 Tips und Tricks
	[ nil, nil, nil, nil, nil ], # 9 Windows reparieren
	[ nil, nil, nil, nil, nil ], # 10 Daten wiederherstellen -> Backup zurück
	[ nil, nil, nil, nil, nil ], # 11 Daten sichern -> Daten manuell sichern
	[ nil, nil, nil, nil, nil ], # 12 Daten sichern -> Festplatte sichern und wiederh...
	[ nil, nil, nil, nil, nil ], # 13 Daten sichern -> Festplatte klonen
	[ nil, nil, nil, nil, nil ], # 14 PC Sicherheit -> Sicherheitscheck 
	[ nil, nil, nil, nil, nil ], # 15 PC Sicherheit -> Sicher surfen
	[ nil, nil, nil, nil, 16 ], # 16 Hardware reparieren
	[ nil, nil, nil, nil, nil ], # 17 Hardware reparieren -> Hardware testen -> USB-Laufwerk prüfen
	[ nil, nil, nil, nil, nil ], # 18 USB Installation # 3 
	[ nil, nil, nil, nil, 19 ], # 19 Info # 5
	[ nil, nil, nil, nil, nil ], # 20 Info -> Umsetzung # 4
	
]
@rightboxes = []
@groupnames = [] 

0.upto(19) { |n|
	groupname = Gtk::EventBox.new.add(Gtk::Image.new("images/right/#{n+1}_groupname.png"))
	fixed.put(groupname, 298, 152) 
	@groupnames.push groupname 
	@rightboxes[n] = []
	0.upto(@buttoncounts[n]) { |o|
		inactbox = Gtk::EventBox.new.add(Gtk::Image.new("images/right/#{n+1}_#{o}_inactive.png"))
		fixed.put(inactbox, 298, 231 + 71 * o) 
		unless @subscreens[n][o].nil?
			inactbox.signal_connect("button_release_event") {
				change_active_box(@subscreens[n][o])
				puts n.to_s 
			}
		end
		@rightboxes[n].push(inactbox) 
	}
}


bc = 0
topbcommands = Hash.new
topbscreens = Hash.new
topbuttons.each { |b|
	fixed.put(b, topboffsets[bc], 100)
	unless topbcommandstrings[bc].nil?
		topbcommands[b] = topbcommandstrings[bc]
		b.signal_connect("button_release_event") { |obj, event|
			system(topbcommands[obj] + " &")
		}
	end
	unless topbcommandscreens[bc].nil?
		topbscreens[b] = topbcommandscreens[bc]
		b.signal_connect("button_release_event") { |obj, event|
			change_active_box(topbscreens[obj])
		}
	end
	bc += 1
}

window.add fixed
window.show_all 
@active_boxes_left.each{ |b| b.hide_all }
@inactive_boxes_left.each{ |b| b.show_all }
@inactive_boxes_left[0].hide_all 
@active_boxes_left[0].show_all 
@rightboxes.each { |n|
	n.each { |o|
		o.hide_all
	}
}
@rightboxes[0].each { |o| o.show_all }
@groupnames.each { |n| n.hide_all }
@groupnames[0].show_all 
#leftbuttons[0].show_all
#rightboxes.each{ |b| b.hide_all } 
#rightboxes[0].show_all
Gtk.main
